﻿;/////////////////////////////////////////////////////////////;
;                                                             ;
;                          SimpleDX11                         ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;         Inspired by the RasterTek DirectX11 tutorials       ;
;             http://www.rastertek.com/tutdx11.html           ;
;/////////////////////////////////////////////////////////////; 



; SimpleDX11 SimpleDX11 modul declaration
DeclareModule SimpleDX11
  Global *ptr
  ;/////////////////////////////////////
  ; Set the SimpleDX11 directory and the Directx11 SDK lib directory
  ; This is important do not forget this!
  #SDX_DIR       = "E:\Projekte\SimpleDX11\"
  #DXSDK_LIB_DIR = "C:\Program Files (x86)\Microsoft DirectX SDK (June 2010)\Lib\"
  ;/////////////////////////////////////      
    
  
  ; SimpleDX11 constants
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    #X86_X64 = "x86"
  CompilerElse
    #X86_X64 = "x64"
  CompilerEndIf
  
  
  #LIB_DXGI           = #DXSDK_LIB_DIR + #X86_X64 + "\dxgi.lib"
  #LIB_D3D10          = #DXSDK_LIB_DIR + #X86_X64 + "\d3d10.lib"
  #LIB_D3D11          = #DXSDK_LIB_DIR + #X86_X64 + "\d3d11.lib"
  #LIB_D3DX10         = #DXSDK_LIB_DIR + #X86_X64 + "\d3dx10.lib"
  #LIB_D3DX11         = #DXSDK_LIB_DIR + #X86_X64 + "\d3dx11.lib"
  #LIB_DXGUID         = #DXSDK_LIB_DIR + #X86_X64 + "\dxguid.lib"
  #LIB_D3DCOMPILER    = #DXSDK_LIB_DIR + #X86_X64 + "\D3DCompiler.lib"
        
  ; SimpleDX11 header include
  IncludeFile #SDX_DIR + "includes\SimpleDX11_Interfaces.pbi"
  IncludeFile #SDX_DIR + "includes\SimpleDX11_Imports.pbi" 
  IncludeFile #SDX_DIR + "includes\SimpleDX11_Constants.pbi"
  IncludeFile #SDX_DIR + "includes\SimpleDX11_Structures.pbi" 

  
  ; Procedure declarations
 ; IncludeFile #SDX_DIR + "procedures\SimpleDX11\d_SimpleDX11.pbi"
    
  ; Interface declarations
  IncludeFile #SDX_DIR + "interfaces\Screen3D\i_Screen3D.pbi"
  IncludeFile #SDX_DIR + "interfaces\Light\i_Light.pbi"
  IncludeFile #SDX_DIR + "interfaces\Texture\i_Texture.pbi"
  IncludeFile #SDX_DIR + "interfaces\Camera\i_Camera.pbi"
  IncludeFile #SDX_DIR + "interfaces\Model\i_Primitive.pbi"
  IncludeFile #SDX_DIR + "interfaces\Model\i_Mesh.pbi"
  IncludeFile #SDX_DIR + "interfaces\Model\i_Model.pbi"
  IncludeFile #SDX_DIR + "interfaces\Shader\i_Compiler.pbi"
  IncludeFile #SDX_DIR + "interfaces\Shader\i_Shader.pbi"

EndDeclareModule


Module SimpleDX11
  
  ; Include the SimpleDX11 modul procedures 
  IncludeFile #SDX_DIR + "procedures\SimpleDX11\p_SimpleDX11.pbi"
  
  
  ;Interface procedures   
  IncludeFile #SDX_DIR + "procedures\Screen3D\p_Screen3D.pbi"
  IncludeFile #SDX_DIR + "procedures\Light\p_Light.pbi"
  IncludeFile #SDX_DIR + "procedures\Texture\p_Texture.pbi"
  IncludeFile #SDX_DIR + "procedures\Camera\p_Camera.pbi"
  IncludeFile #SDX_DIR + "procedures\Model\p_Primitive.pbi"
  IncludeFile #SDX_DIR + "procedures\Model\p_Mesh.pbi"
  IncludeFile #SDX_DIR + "procedures\Model\p_Model.pbi"
  IncludeFile #SDX_DIR + "procedures\Shader\p_Compiler.pbi"
  IncludeFile #SDX_DIR + "procedures\Shader\p_Shader.pbi"   
   
EndModule 



  

; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 54
; FirstLine = 29
; Folding = -
; EnableUnicode
; EnableXP