﻿;/////////////////////////////////////////////////////////////;
;                                                             ;
;              SimpleDX11 Demo 1 (First Triangle)             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;    
;/////////////////////////////////////////////////////////////;

; Initialize the PB Spritesystem and use the DirectX11 subsystem
InitSprite()

;Include the SimpleDX11 main file (change the pathes in there before using it)
XIncludeFile "../../SimpleDX11.pbi"


; Initialize Keyboard
If Not InitKeyboard()
  MessageRequester("Error", "Could not initialize the keyboard!")
  End  
EndIf



; Open a Window
#Window = 0
If OpenWindow(#Window, 50, 200, 800, 600,"SimpleDX11 First Triangle",#PB_Window_SystemMenu | #PB_Window_SizeGadget)
  If Not OpenWindowedScreen(WindowID(#Window), 0, 0, WindowWidth(#Window), WindowHeight(#Window))  
    MessageRequester("Error", "Could not open the Screen!")
    End    
  EndIf  
Else  
  MessageRequester("Error", "Could not open the Window!")
  End
EndIf

; Must be used after OpenScreen / OpenWindowedScreen
UseModule SimpleDX11

Define *Screen3D.Screen3D = New_Screen3D()


; Add a camera
Define *Camera.Camera = New_Camera(*Screen3D) 
*Camera\SetPosition(0.0,0.0,-3.0)

; Add a model
*Model.Model = New_Model(*Screen3D, #SDX_Vertex_Colors)
*Model\AddTriangle(1.0, $BF8122)
*Model\SetModel()


*vShader.Shader = New_Shader(*Screen3D, #VertexShader)

If *vShader\CompileShaderFile("Shader\Vertex.vs", "VShader", "vs_5_0") 
   *vShader\Release() : *Model\Release() : *Camera\Release() : *Screen3D\Release() : End
  End 
EndIf

*pShader.Shader = New_Shader(*Screen3D, #PixelShader)
If *pShader\CompileShaderFile("Shader\Pixel.ps", "PShader", "ps_5_0")    
  *pShader\Release() : *Model\Release() : *Camera\Release() : *Screen3D\Release() : End
  End 
EndIf

ShaderDataDesc.Shader_DataDescription
ShaderDataDesc\Camera = *Camera
CopyMemory(*Screen3D\GetWorldMatrix(), ShaderDataDesc\WorldMatrix, SizeOf(D3DMATRIX))
CopyMemory(*Screen3D\GetProjectionMatrix(), ShaderDataDesc\ProjectionMatrix, SizeOf(D3DMATRIX))

Repeat  
  ExamineKeyboard()
  Event.l = WindowEvent()  
  
  FlipBuffers()
  ClearScreen($799FFF)
  
  *Screen3D\Start3D()  
    *Camera\Render()
     
    ; Set the shader data
    *vShader\SetShaderData(ShaderDataDesc)    
    
    ; Render all the shader and vertexbuffer ....    
   	*vShader\Render()
   	*pShader\Render()   
   	
   	*Model\Render()     	
  *Screen3D\Stop3D()
  
  Delay(1)
Until Event = #PB_Event_CloseWindow Or KeyboardPushed(#PB_Key_Escape)

; Release SimpleDX11 from Memory
; Do not forget this!

*Camera\Release()
*vShader\Release()
*pShader\Release()
*Screen3D\Release()
UnuseModule SimpleDX11

CloseScreen()



; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 48
; FirstLine = 15
; EnableUnicode
; EnableXP
; SubSystem = DirectX11