cbuffer ConstantBuffer : register(b0)
{
        float4x4 World;
        float4x4 View;
        float4x4 Projection;
};

struct VInput
{
    float4 position : POSITION;
    float2 tex		: TEXCOORD0;
};
struct PixelOutput
{
    float4 position : SV_POSITION;
    float2 tex		: TEXCOORD0;
};
PixelOutput VShader(VInput Input)
{
    PixelOutput output;


    output.position = Input.position;
    Input.position.w = 1.0f;
    output.position = mul(Input.position, World);
    output.position = mul(output.position, View);
    output.position = mul(output.position, Projection);
	output.tex		= Input.tex;
    return output;
}