// SimpleDX11 default VertexShader ConstantBuffer
cbuffer ConstantBuffer
{
        float4x4 World;
        float4x4 View;
        float4x4 Projection;
};

struct VInput
{
    float4 position : POSITION;
    float4 normal   : NORMAL;
    float4 color 	: COLOR;
};
struct PixelOutput
{
    float4 position : SV_POSITION;
    float4 color 	: COLOR;
};
PixelOutput VShader(VInput Input)
{
    PixelOutput output;
    output.position = Input.position;
    output.position = mul(Input.position, World);
    output.position = mul(output.position, View);
    output.position = mul(output.position, Projection);
	output.color	= Input.color;
    return output;
}